﻿using CAS_169708.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Infragistics.Web.Mvc;
using System.Web.Script.Serialization;

namespace CAS_169708.Controllers
{
    public class HomeController : Controller
    {



        public ActionResult Index()
        {
            return View();
        }

        public ActionResult About()
        {
            return View(GetCars());
        }

        public ActionResult Contact()
        {
            var deleted = new JavaScriptSerializer().Serialize(GetDeletedCars());

            return View(new CarCollection(Repository.Repository.Instance.AsQueryable(), deleted));
        }

        [HttpPost]
        public ActionResult DeleteItem(int deletedCarIndex, bool isRemoveFromList = false)
        {
            Car car = null;
            var list = isRemoveFromList ? GetCars().ToList() : Repository.Repository.Instance;
            if (deletedCarIndex < list.Count)
            {
                car = list[deletedCarIndex];
            }

            if (car != null)
            {
                car.isDeleted = true;
            }

            var json = new JavaScriptSerializer().Serialize(GetDeletedCars());

            return Content(json);
        }        

        private IQueryable<Car> GetCars()
        {
            return Repository.Repository.Instance
                    .Where(c => !c.isDeleted)                    
                    .AsQueryable();
        }

        private IQueryable<int> GetDeletedCars()
        {
            return Repository.Repository.Instance                    
                    .Where(c => c.isDeleted)
                    .Select(c => Repository.Repository.Instance.IndexOf(c))
                    .AsQueryable();
        }
    }
}